#include <stdio.h>
#include <stdlib.h>
#include <sysexits.h>

#ifdef  HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef  HAVE_UNISTD_H
#include <unistd.h>
#endif

#include <strfunc.h>

char **func(char *found, void *optKeyPassed) {
	static char *tmp[2] = {NULL};

	(void)optKeyPassed;

	if(*found == '1') {
		*tmp = "value mapped from 1";
		return tmp;
	}

	if(*found == '2') {
		*tmp = "value mapped from 2";
		return tmp;
	}

	if(*found == '3') {
		static char *zzz[] = { "3:one", "3:two", "3:three", NULL };
		return zzz;
	}

	return NULL;
}

int
main() {

	fmt_base *fb;

	fb = format_init();

	if(!fb) {
		perror("format_init() failed");
		exit(1);
	}

	format_metarule(fb, '{', '}', func);

	printf("%s",
		formatf(fb, "${1}\n${2}\n${1?${3+\n\t}}\n", NULL)
	);


	format_free(fb);

	return 0;
}
